<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates&#x2F;framework&#x2F;dyndl&#x2F;realize&#x2F;simple&#x2F;src&#x2F;lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../dyndl_realize_simple/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
</pre><pre class="rust"><code><span class="attribute">#![<span class="ident">no_std</span>]</span>

<span class="kw">use</span> <span class="ident">dyndl_realize</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">dyndl_realize_simple_config</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">dyndl_types</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">icecap_core::prelude</span>::<span class="kw-2">*</span>;

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">initialize_simple_realizer_from_config</span>(<span class="ident">config</span>: <span class="kw-2">&amp;</span><span class="ident">RealizerConfig</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Fallible</span><span class="op">&lt;</span><span class="ident">Realizer</span><span class="op">&gt;</span> {
    <span class="comment">// Unmap dummy pages</span>
    <span class="ident">config</span>.<span class="ident">small_page</span>.<span class="ident">unmap</span>()<span class="question-mark">?</span>;
    <span class="ident">config</span>.<span class="ident">large_page</span>.<span class="ident">unmap</span>()<span class="question-mark">?</span>;

    <span class="kw">let</span> <span class="ident">cregion</span> <span class="op">=</span> {
        <span class="kw">let</span> <span class="ident">config</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">config</span>.<span class="ident">allocator_cregion</span>;
        <span class="kw">let</span> <span class="ident">root</span> <span class="op">=</span> <span class="ident">config</span>
            .<span class="ident">root</span>
            .<span class="ident">root</span>
            .<span class="ident">relative_cptr</span>(<span class="ident">config</span>.<span class="ident">root</span>.<span class="ident">cptr</span>, <span class="ident">config</span>.<span class="ident">root</span>.<span class="ident">depth</span>);
        <span class="ident">CRegion::new</span>(
            <span class="ident">root</span>,
            <span class="ident">config</span>.<span class="ident">guard</span>,
            <span class="ident">config</span>.<span class="ident">guard_size</span>,
            <span class="ident">config</span>.<span class="ident">slots_size_bits</span>,
        )
    };

    <span class="kw">let</span> <span class="ident">allocator</span> <span class="op">=</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">builder</span> <span class="op">=</span> <span class="ident">AllocatorBuilder::new</span>(<span class="ident">cregion</span>);
        <span class="kw">for</span> <span class="ident">DynamicUntyped</span> {
            <span class="ident">slot</span>,
            <span class="ident">size_bits</span>,
            <span class="ident">paddr</span>,
            ..
        } <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="ident">config</span>.<span class="ident">untyped</span>
        {
            <span class="ident">builder</span>.<span class="ident">add_untyped</span>(<span class="ident">ElaboratedUntyped</span> {
                <span class="ident">cptr</span>: <span class="kw-2">*</span><span class="ident">slot</span>,
                <span class="ident">untyped_id</span>: <span class="ident">UntypedId</span> {
                    <span class="ident">size_bits</span>: <span class="kw-2">*</span><span class="ident">size_bits</span>,
                    <span class="ident">paddr</span>: <span class="ident">paddr</span>.<span class="ident">unwrap</span>(), <span class="comment">// HACK</span>
                },
            });
        }
        <span class="ident">builder</span>.<span class="ident">build</span>()
    };

    <span class="kw">let</span> <span class="ident">initialization_resources</span> <span class="op">=</span> {
        <span class="kw">let</span> <span class="ident">config</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">config</span>.<span class="ident">initialization_resources</span>;
        <span class="ident">SubsystemObjectInitializationResources</span> {
            <span class="ident">pgd</span>: <span class="ident">config</span>.<span class="ident">pgd</span>,
            <span class="ident">asid_pool</span>: <span class="ident">config</span>.<span class="ident">asid_pool</span>,
            <span class="ident">tcb_authority</span>: <span class="ident">config</span>.<span class="ident">tcb_authority</span>,
            <span class="ident">small_page_addr</span>: <span class="ident">config</span>.<span class="ident">small_page_addr</span>,
            <span class="ident">large_page_addr</span>: <span class="ident">config</span>.<span class="ident">large_page_addr</span>,
        }
    };

    <span class="kw">let</span> <span class="ident">externs</span> <span class="op">=</span> <span class="ident">config</span>
        .<span class="ident">externs</span>
        .<span class="ident">iter</span>()
        .<span class="ident">map</span>(<span class="op">|</span>(<span class="ident">k</span>, <span class="ident">v</span>)<span class="op">|</span> {
            (
                <span class="ident">k</span>.<span class="ident">clone</span>(),
                <span class="ident">Extern</span> {
                    <span class="ident">ty</span>: <span class="ident">v</span>.<span class="ident">ty</span>,
                    <span class="ident">cptr</span>: <span class="ident">Unspecified::from_raw</span>(<span class="ident">v</span>.<span class="ident">cptr</span>),
                },
            )
        })
        .<span class="ident">collect</span>();

    <span class="prelude-val">Ok</span>(<span class="ident">Realizer::new</span>(<span class="ident">initialization_resources</span>, <span class="ident">allocator</span>, <span class="ident">externs</span>))
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">fill_frames_simple</span>(
    <span class="ident">realizer</span>: <span class="kw-2">&amp;</span><span class="ident">Realizer</span>,
    <span class="ident">partial_subsystem</span>: <span class="kw-2">&amp;</span><span class="ident">PartialSubsystem</span>,
    <span class="ident">fill_blob</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Fallible</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">offset</span> <span class="op">=</span> <span class="number">0</span>;
    <span class="kw">for</span> (<span class="ident">i</span>, <span class="ident">obj</span>) <span class="kw">in</span> <span class="ident">partial_subsystem</span>.<span class="ident">model</span>.<span class="ident">objects</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>() {
        <span class="kw">if</span> <span class="kw">let</span> <span class="ident">AnyObj::Local</span>(<span class="ident">obj</span>) <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">obj</span>.<span class="ident">object</span> {
            <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">fill</span>) <span class="op">=</span> <span class="kw">match</span> <span class="ident">obj</span> {
                <span class="ident">Obj::SmallPage</span>(<span class="ident">frame</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="kw-2">&amp;</span><span class="ident">frame</span>.<span class="ident">fill</span>),
                <span class="ident">Obj::LargePage</span>(<span class="ident">frame</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="kw-2">&amp;</span><span class="ident">frame</span>.<span class="ident">fill</span>),
                <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
            } {
                <span class="kw">for</span> (<span class="ident">j</span>, <span class="ident">entry</span>) <span class="kw">in</span> <span class="ident">fill</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>() {
                    <span class="kw">let</span> <span class="ident">next_offset</span> <span class="op">=</span> <span class="ident">offset</span> <span class="op">+</span> <span class="ident">entry</span>.<span class="ident">length</span>;
                    <span class="ident">realizer</span>.<span class="ident">realize_continue</span>(
                        <span class="ident">partial_subsystem</span>,
                        <span class="ident">i</span>,
                        <span class="ident">j</span>,
                        <span class="kw-2">&amp;</span><span class="ident">fill_blob</span>[<span class="ident">offset</span>..<span class="ident">next_offset</span>],
                    )<span class="question-mark">?</span>;
                    <span class="ident">offset</span> <span class="op">=</span> <span class="ident">next_offset</span>;
                }
            }
        }
    }
    <span class="prelude-val">Ok</span>(())
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="dyndl_realize_simple" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>